/*
 * Copyright (C) 2005, 2009  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "searchdata.h"
#include "../shared/lib_conversions.h"
#include "basetools.h"

#include <iostream>

void SearchData::setWords(std::string text)
{
  std::set<std::string> kwset = BaseTools::KeywordList_Set(strU(text));
  std::set<std::string>::iterator it;
  
  for (it = kwset.begin(); it != kwset.end(); it++)  
    words.push_back(*it);  
}

void SearchData::removeMatchingWords(std::string text)
{
  unsigned int n = 0;
  
  text = strU(text);
  
  while (n < words.size())
  {
    if (text.find(words[n]) != std::string::npos)    
      words.erase(words.begin() + n);          
    else    
      n++;
  }  
}

void SearchData::AddWords(std::string& text)
{
  for (unsigned int n=0; n<words.size(); n++)
    text += words[n] + "\n";
}
