/*
 * Copyright (C) 2005, 2008, 2010  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef TREEGROUPDATA_H
# define TREEGROUPDATA_H

# include "treegroupbase.h"

/**
 * A real group, which contains its own description and 
 * points to children.
 */
class TreeGroupData : public TreeGroupBase
{
public:
  
  /**
   *
   */
  virtual std::string getText();
  
  /**
   *
   */
  virtual std::string getComment();
  
  /**
   *
   */
  virtual std::string getKeywords();
  
  /**
   * 
   */
  TreeGroupData(TreeItem* prev, TreeGroupBase* parent);
  
  /**
   * 
   */
  virtual ~TreeGroupData();
  
  /**
   * 
   */
  virtual int loadFromXML_all(SimpleXMLTransfer*    source,
                              LinkInfo*             links);
  
  /**
   * 
   */
  virtual int saveToXML_all(SimpleXMLTransfer* dest, bool fConvLinks, int nVersion);
  
  /**
   * 
   */
  virtual int saveToXML_properties(SimpleXMLTransfer* dest, bool fConvLinks, int nVersion);
  
  /**
   * 
   */
  virtual enum eItemLinkType getLinkType();
  
  /**
   * 
   */
  virtual void setTitle(const char* newtitle);
  
  /**
   * 
   */
  virtual void setKeywords(const char* nK);
  
  /**
   * 
   */
  virtual void setComment(const char* nC);
  
  /**
   * Connect and/or count links.
   */
  virtual int connectLinks(LinkInfo* links);
  
private:
  
  /**
   * 
   */
  std::string title;
  
  /**
   * 
   */
  std::string keywords;
  
  /**
   * 
   */
  std::string comment;   
};
#endif
