/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "treegrouproot.h"
#include "treeview.h"

#include "xmldefs.h"

TreeGroupRoot::TreeGroupRoot(TreeItem* prev, TreeGroupBase* parent, TreeView* view) : TreeGroupData(prev, parent)
{
  myView = view;
}

TreeGroupRoot::~TreeGroupRoot()
{
  deleteChildren();
}

enum TreeItem::eItemLinkType TreeGroupRoot::getLinkType()
{
  return(ROOTDATA);
}

std::string TreeGroupRoot::getBasepath()
{
  return(myView->getBasepath());
}

StringSet* TreeGroupRoot::getHiddenKeywords()
{
  return(myView->getHiddenKeywords());
}

