/*
 * Copyright (C) 2005, 2010  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef TREEGROUPROOT_H
#define TREEGROUPROOT_H

#include "treegroupdata.h"

#include <set>


typedef std::set<std::string> StringSet;

class TreeView;

/**
 * The parent of all TreeItems. 
 * It does hold information common to all its children.
 */
class TreeGroupRoot : public TreeGroupData
{
  public:
   
   /**
    * 
    */
   TreeGroupRoot(TreeItem* prev, TreeGroupBase* parent, TreeView* view);

   /**
    * 
    */
   virtual ~TreeGroupRoot();
   
   /**
    * 
    */
   virtual enum eItemLinkType getLinkType();

   /**
    * 
    */
   std::string getBasepath();
   
   /**
    * 
    */
   StringSet* getHiddenKeywords();
  
   void SetVersionInfo(int nVer) { nVersion = nVer; };
   int  GetVersionInfo()         { return(nVersion); };
  
  private:
   
   TreeView* myView;
  
   int nVersion;
};
#endif
