/*
 * Copyright (C) 2005, 2007, 2010  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef TREEPICBASE_H
# define TREEPICBASE_H

# include "treeitem.h"
# include "datetime.h"
# include "searchdata.h"

class TreeView;

class TreePicBase : public TreeItem
{
public:
  
  TreePicBase(TreeItem* prev, TreeGroupBase* parent);
  
  virtual ~TreePicBase();
  
  /**
   * 
   */
  virtual int loadFromXML_all(SimpleXMLTransfer*    source,
                              LinkInfo*             links) = 0;
  
  /**
   * 
   */
  virtual int saveToXML_all(SimpleXMLTransfer* dest, bool fConvLinks, int nVersion) = 0;
  
  /**
   * 
   */
  enum eItemType getType();
  
  /**
   * 
   */
  virtual enum eItemLinkType getLinkType() = 0;
  
  /*
   * 
   */
  virtual std::string getPath() = 0;
  
  /**
   * 
   */
  virtual std::string getTimeString() = 0;
  
  /**
   * 
   */
  virtual std::string getDateString() = 0;
  
  /**
   * 
   */
  virtual unsigned int getYear() = 0;
  
  /**
   * 
   */
  virtual bool hasTime() = 0;
  
  /**
   * 
   */
  virtual bool hasDate() = 0;
  
  /**
   * 
   */
  virtual JWWDateTime getDateTime() = 0;
  
  /**
   * 
   */
  virtual std::string getDescr(int level, bool fShort = false) = 0;
  
  /**
   * returns 0 on success
   */
  virtual int setDate(const char* nD) = 0;
  
  /**
   * returns 0 on success
   */
  virtual int setTime(const char* nT) = 0;
  
  /**
   * 
   */
  int editGimp(std::string bp);
    
  /**
   * 
   */
  bool markIfMatch(SearchData sd, TreeView* DataToMark);
  
  /**
   * 
   */
  bool markIfWithoutText();
  
  /**
   * 
   */
  virtual void timeshift(int nSec) = 0;
  
  /**
   * 
   */
  int GetFileSize(std::string bp);
  
private:  
  enum T_eRotMethod { eRotUnknown=0, eRotNone=1, eRotJPEGTran=2, eRotConvert=3 };
  static enum T_eRotMethod eRotMethod;
};
#endif
