/*
 * Copyright (C) 2005, 2010  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef TREEPICLINK_H
#define TREEPICLINK_H

#include "treepicbase.h"
#include "links.h"

class TreePicLink : public TreePicBase
{
  public:

   /**
    *
    */
   virtual std::string getText();

   /**
    *
    */
   virtual std::string getSomeText(eText whichText);
   
   /**
    * 
    */
   TreePicLink(TreeItem* prev, TreeGroupBase* parent);
   
   /**
    * 
    */
   TreePicLink(TreeItem* prev, TreeGroupBase* parent, TreeItem* dest);
   
   /**
    * 
    */
   virtual ~TreePicLink();
   
   /**
    * 
    */
   virtual unsigned int getLinkID() { return(linkID); };
   
   /**
    * 
    */
   virtual TreeItem* getLinkPtr() { return((TreeItem*)linkptr); };
   
   /**
    * 
    */
   virtual int loadFromXML_all(SimpleXMLTransfer*    source,
                               LinkInfo*             links);
   
   /**
    * 
    */
   virtual int saveToXML_all(SimpleXMLTransfer* dest, bool fConvLinks, int nVersion);
   
   /**
    * 
    */
   virtual enum eItemLinkType getLinkType();
   
   /*
    * 
    */
   virtual std::string getPath();

   /**
    * 
    */
   virtual std::string getComment();

   /**
    * 
    */
   virtual std::string getKeywords();

   /**
    * 
    */
   virtual std::string getTimeString();

   /**
    * 
    */
   virtual std::string getDateString();

   /**
    * 
    */
   virtual unsigned int getYear();

   /**
    * 
    */
   virtual bool hasTime();

   /**
    * 
    */
   virtual bool hasDate();

   /**
    * 
    */
   virtual JWWDateTime getDateTime();

   /**
    * 
    */
   virtual std::string getDescr(int level, bool fShort = false);
   
   /** 
    * Pointer to the TreePicData. Used to recognize duplicates.
    */
   TreePicBase* getDataSource();
   
   /**
    * Connect links.
    */
   virtual int connectLinks(LinkInfo* links);
      
   /**
    * 
    */
   virtual void setKeywords(const char* nK);

   /**
    * 
    */
   virtual void setComment(const char* nC);

   /**
    * 
    */
   virtual int setDate(const char* nD);

   /**
    * 
    */
   virtual int setTime(const char* nT);

   /**
    * 
    */
   virtual JWWDateTime getDT();
      
   /**
    * 
    */
   void timeshift(int nSec);
   
   /**
    * Returns true if this picture is hidden because of something
    */
   virtual bool isHidden();
   
  private:
   /**
    * The real picture to which I link.
    */
   TreePicBase* linkptr;
   
   /**
    * The real picture to which I link. In 'virtual views' like chronological views
    * or search results this is zero and only linkptr is valid!
    */
   unsigned int linkID;   
};
#endif

