/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "addpicsdlg.h"

AddPicsDlg::AddPicsDlg() 
{
  Fl_Double_Window* w;
  { 
    Fl_Double_Window* o = myWindow = new Fl_Double_Window(575, 180, "Add pictures");
    w = o;
    o->user_data((void*)(this));
    { 
      Fl_Choice* o = cb_dtmethod = new Fl_Choice(155, 20, 400, 35, "How to set date/time");
      o->down_box(FL_BORDER_BOX);
      o->add("try EXIF, otherwise no date and time");
      o->add("try EXIF, otherwise date and time of file");
      o->add("try EXIF, otherwise date of file, no time");
      o->add("date and time of file");
      o->value(2);
    }
    btn_cancel = new Fl_Button(25, 125, 150, 35, "Cancel");
    btn_ok = new Fl_Return_Button(200, 125, 150, 35, "OK");
    o->end();
  }
}

AddPicsDlg::~AddPicsDlg()
{
  delete myWindow;
}

TreePicData::eDateTimeSource AddPicsDlg::showDlg()
{
  TreePicData::eDateTimeSource retCode;
  
  myWindow->set_modal();
  myWindow->show();
      
  for (;;)
  {
    Fl_Widget *o = Fl::readqueue();
    
    if (!o) 
    {
      Fl::wait();
    }
    else if (o == btn_cancel || o == myWindow)
    {
      retCode = TreePicData::eABORT;
      break;
    }
    else if (o == btn_ok)
    {
      retCode = (TreePicData::eDateTimeSource)(cb_dtmethod->value());
      break;
    }    
  }
    
  myWindow->hide();
  return(retCode);
}
