/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "itemchange.h"

#include <iostream>
#include "gui.h"
#include "../base/treeitem.h"
#include "../base/treeview.h"

ItemChange::~ItemChange()
{
}

void ItemChange::connectItemChange(ItemChange* partnerptr) 
{ 
  myItemChangePartner = partnerptr; 
};

void ItemChange::sayItemChanged(TreeItem* ptr)
{
  if (myItemChangePartner != (ItemChange*)0)
  {
    std::cout << this << " is calling " << myItemChangePartner << "->itemChanged("<< ptr << ")\n";
    myItemChangePartner->itemChanged(ptr);
  }
}

void ItemChange::setGUI(UserInterface* mygui) 
{ 
  gui = mygui; 
}

void ItemChange::setData(TreeView* newData) 
{ 
  treeview = newData; 
}

void ItemChange::showContextMenu(int       m_x,
                                 int       m_y,
                                 TreeItem* i)
{ 
  gui->showContextMenu(m_x, m_y, i); 
}
