/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef ITEMCHANGE_H
#define ITEMCHANGE_H


class TreeItem;
class UserInterface;
class TreeView;

class ItemChange
{
  public:
   virtual ~ItemChange();
  
   virtual void itemChanged(TreeItem* ptr) = 0;
   
   void connectItemChange(ItemChange* partnerptr);

   void sayItemChanged(TreeItem* ptr);

   void setGUI(UserInterface* mygui);
   void setData(TreeView *newData);
  
   inline TreeView* getData() { return(treeview); };
   
   void showContextMenu(int       m_x,
                        int       m_y,
                        TreeItem* i);
      
  protected:
   ItemChange*     myItemChangePartner;
   TreeView*       treeview;
   UserInterface*  gui;
};

#endif
