/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef PICGROUP_H
#define PICGROUP_H

#include <FL/Fl_Scroll.H>

#include "textbox.h"
#include "itemchange.h"

class PicGroup : public Fl_Scroll, public ItemChange
{
  public:
   PicGroup(int,int,int,int, const char *);
   virtual ~PicGroup();
   virtual void resize(int x, int y, int w, int h);
   void draw();
   void setDescr(std::string newdescr);
   void clear();
   
   /**
    * Stores a pointer to the item which was the last one
    * marked with ctrl+left click.
    */
   void*  lastMarkedItemCtrl;
   
   /**
    * Stores a pointer to the item which was the last one 
    * in a range marked with shift+left click.
    */
   void*  lastMarkedItemShift;
   
   int  setMarkItemUpTo(void* ptr);
   virtual void itemChanged(TreeItem* ptr);
  private:
   TextBox*  textbox;   
};

#endif
