/*
 * Copyright (C) 2005  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef PICTREEBROWSER_H
#define PICTREEBROWSER_H

# include <FL/Fl_Browser_.H>
#include "../base/treeview.h"
#include "../base/treeitem.h"
#include "itemchange.h"

class PicTreeBrowser : public Fl_Browser_, public ItemChange
{
   // required routines for Fl_Browser_ subclass:
   void *item_first() const ;
   void *item_next(void *) const ;
   void *item_prev(void *) const ;
   int  item_width(void *) const ;
   int  item_height(void *) const ;
   void item_draw(void *,int,int,int,int) const ;
 
   
      
  public:	   
   virtual void itemChanged(TreeItem* ptr);
   int handle(int);
   PicTreeBrowser(int,int,int,int,const char *);

   void      textsize(uchar s);
   TreeItem* itemSelected;
   
   void setShowPics(bool fNew);
   
   bool showPics() { return(fShowPics); }
         
  private:
   bool fShowPics;     
   
   /**
    * 
    */
   int nItemHeight;
   
   /**
    * 
    */
   int nSizeBox;
   
   /**
    * 
    */
   int nLengthDash;
   
   /**
    * 
    */
   int nD;
   
   /**
    * copy of int Fl_Browser_::textsize()
    */
   int nTextsize;
   
   /**
    * 
    */
   int nGroupAdd;
};

#endif
