/*
 * Copyright (C) 2005, 2008  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#ifndef searchdlg_h
# define searchdlg_h

#define BROWSER 1


# include <set>
# include <string>
# include <FL/Fl.H>
# include <FL/Fl_Double_Window.H>
# include <FL/Fl_Input.H>
# include <FL/Fl_Check_Button.H>
# include <FL/Fl_Button.H>
# include <FL/Fl_Return_Button.H>
# include "../base/searchdata.h"

#if (BROWSER == 0)
# include <FL/Fl_Select_Browser.H>
#define KWSRCHBROWSER Fl_Select_Browser
#else
# include "texttree.h"
#define KWSRCHBROWSER TextTreeBrowser
#endif


class SearchDlg {
public:
  SearchDlg(std::set<std::string>& kwset);
  ~SearchDlg();
  
  int showDlg();
  
  void setData(SearchData* data);

  void AddKw(const char* item);
  
  Fl_Input *ti_wordnew;
  Fl_Input *ti_words;
private:
  Fl_Check_Button *cb_keywords;
  Fl_Check_Button *cb_comment;
  Fl_Check_Button *cb_title;
  Fl_Check_Button *cb_path;
  Fl_Check_Button *cb_groups;
  Fl_Check_Button *cb_wholeword;

  Fl_Button*        btn_cancel;
  Fl_Button*        btn_mark;
  Fl_Return_Button* btn_search;
  Fl_Double_Window* myWindow;
  
  KWSRCHBROWSER*    brw_kws; 
};
#endif
