/*
 * Copyright (C) 2011  Jens Wilhelm Wulf, j dot w dot wulf at gmx dot net
 * Licensed under the GNU General Public License version 2.
 */

#include "thread.h"

namespace SimpleThread
{
   
#ifdef WIN32
   int Create(void *(*f) (void *), void* p) 
   {
     if (_beginthread((void( __cdecl * )( void * ))f, 0, p) == -1L)
       return(-1);
     else
       return(0);
   }
   
   void Exit()
   {
     _endthread();
   }
#else
   
   int Create(void *(*f) (void *), void* p)
   {
     pthread_t t;
     pthread_attr_t attr;
     pthread_attr_init(&attr);
     pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);
     return(pthread_create(&t, &attr, f, p));
   }
      
   void Exit()
   {
     pthread_exit(0);
   }
#endif
   
};
